// 005 u_oracle_dbx_modify_cds
// 04 sep 2005

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com


(*$r+*)
unit u_oracle_dbx_modify_cds;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Db, DBTables, Grids, DBGrids, ComCtrls,
  DBXpress, SqlExpr, FMTBcd, DBClient, Provider;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    SQLMonitor1: TSQLMonitor;
    Memo1: TMemo;
    Panel1: TPanel;
    DBGrid1: TDBGrid;
    ApplyUpdates_: TButton;
    open_cds_: TButton;
    SQLConnection1: TSQLConnection;
    SQLQuery1: TSQLQuery;
    DataSetProvider1: TDataSetProvider;
    ClientDataSet1: TClientDataSet;
    display_xml_: TButton;
    close_cds_: TButton;
    exit_: TButton;
    clear_: TButton;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ApplyUpdates_Click(Sender: TObject);
    procedure SQLMonitor1LogTrace(Sender: TObject; CBInfo: pSQLTRACEDesc);
    procedure open_cds_Click(Sender: TObject);
    procedure display_xml_Click(Sender: TObject);
    procedure ClientDataSet1ReconcileError(DataSet: TCustomClientDataSet;
      E: EReconcileError; UpdateKind: TUpdateKind;
      var Action: TReconcileAction);
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure close_cds_Click(Sender: TObject);
    procedure SQLConnection1AfterConnect(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation
  uses u_c_log, u_c_display
    , u_c_cds_table
    , u_c_cds_analyze_xml
    , u_f_reconcile_delphi_oracle
    ;

    {$R *.DFM}

    const k_root_path= '..\_data\';

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.SQLConnection1AfterConnect(Sender: TObject);
      begin
        display('> change decimal');
        SqlConnection1.ExecuteDirect('ALTER SESSION SET NLS_NUMERIC_CHARACTERS=''.,''');
        display('< change decimal');
      end; // SQLConnection1AfterConnect

    procedure TForm1.ApplyUpdates_Click(Sender: TObject);
      var l_erreurs: Integer;
      begin
        l_erreurs:= ClientDataSet1.ApplyUpdates(-1);
        display('erreurs '+ IntToStr(l_erreurs));
      end; // ApplyUpdates_Click

    var g_trace_count: Integer= 0;

    procedure TForm1.SQLMonitor1LogTrace(Sender: TObject;
        CBInfo: pSQLTRACEDesc);
      var l_length: Integer;
          l_text: String;
      begin
        with CBinfo^ do
        begin
          l_length:= uTotalMsgLen;
          // display(IntToStr(l_length));
          if l_length> 0
            then begin
                SetLength(l_text, l_length);
                Move( psztrace, l_text[1], l_length);
                display(l_text);
              end;
        end;

        with SQLMonitor1, TraceList do
          while g_trace_count< Count do
          begin
            display(Strings[g_trace_count]);
            Inc(g_trace_count);
          end;
      end; // SQLMonitor1LogTrace

    procedure TForm1.open_cds_Click(Sender: TObject);
      begin
        ClientDataSet1.Open;
      end; // open_cds_Click

    procedure TForm1.display_xml_Click(Sender: TObject);
      var l_c_table: c_table;
      begin
        // -- save the CDS with some temporary name
        ClientDataset1.SaveToFile(k_root_path+ 'temp.xml');

        // -- reload the CDS and display it
        with c_cds_analyze_xml.create_cds_analyze_xml('xml', k_root_path+ 'temp.xml') do
        begin
          l_c_table:= c_table.create_table('table');
          analyze_xml(l_c_table);

          display_line;
          l_c_table.display_formatted_line_list;
          l_c_table.Free;
          Free;
        end; // with c_analyze_xml
      end; // display_xml_Click

    procedure TForm1.ClientDataSet1ReconcileError(
          DataSet: TCustomClientDataSet; E: EReconcileError;
          UpdateKind: TUpdateKind; var Action: TReconcileAction);
      begin
        display('reconcile '+ e.Message);
        action:= HandleReconcileError(DataSet, UpdateKind, e);
      end; // ClientDataSet1ReconcileError

    procedure TForm1.close_cds_Click(Sender: TObject);
      begin
        ClientDataset1.Close;
       end; // close_cds_Click

end.



